#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>

char	*progname;

main(argc, argv)
	int		argc;
	char		*argv[];
{
	struct hostent	*hp;
	ulong		ipaddr;

	progname = strrchr(argv[0], '/');
	if (progname == NULL)
		progname = argv[0];
	else
		progname++;

	argc--, argv++;

	if (argc == 0 || argv[0][0] == '-') {
		fprintf(stderr, "usage: %s hexInetAddr ...\n", progname);
		exit(1);
	}
	for ( ; argc; argc--, argv++) {
		ipaddr = (ulong)strtol(argv[0], (char **)0, 16);
		hp = gethostbyaddr(&ipaddr, sizeof(ipaddr), AF_INET);

		printf("0x%x => %s: %s\n",
			ipaddr,
			inet_ntoa(ipaddr),
			hp == NULL ? "Unknown host" : hp->h_name
		);
	}
}
